compute.area.under.the.curve <-
function(curve.matrix, above.x=0,left.of.y=NA,increasing.x=TRUE){	
#####################################################################################################################
### To compute the area of the region that is bellow the input curve.
# (and above the line Y=above.x and on the left of the line X=left.of.y).
### INPUT: Each row is the (x,y) coordinate of a point on the curve. 
	if(class(curve.matrix)!="matrix"){
		warning("The input is not a matrix.")
		return(0)
	}#End if.	
	if(dim(curve.matrix)[1]<2)	
		return(0)
	if(is.na(left.of.y))		
		left.of.y <- max(curve.matrix[ ,1])	
	#plot(curve.matrix);a()	
	partial.curve.matrix <- curve.matrix[which(curve.matrix[ ,1]<=left.of.y), ]	
	X <- partial.curve.matrix[ ,1]	
	Y <- partial.curve.matrix[ ,2] - above.x	
	intervals <- c(X[-1],tail(X,1)) - X	# an estimation
	intervals <- (2*increasing.x-1) *  intervals	
		# consider negative sigen if x values are not increasing.
	average.Y <- c(Y[-1],tail(Y,1))	
	area <- intervals %*% average.Y	
	return(area)	
}##########################################################################################################################

