find.cutoff <-
function(density.1,density.2, do.plot=FALSE,colors=c(2,3),xlim=NULL,ylim=NULL,debug.message=FALSE){
### find.cutofffind.cutofffind.cutofffind.cutofffind.cutofffind.cutofffind.cutofffind.cutofffind.cutofffind.cutofffind.cutofffind.cutofffind.cutoff
### Returns the best threshould that minimizes the expected error (= the area under the curves where mislabeled). 
### INPUT: each input density is a matrix with two columns. Each row contains the (x,y) coordinates of a poin.
	
	
	# Input check:
	if(dim(density.1)[1]!=dim(density.2)[1])
		warning("The two input density matrices do not describ the same number of points.")
		
	if(sum(density.1[ ,1]!=density.2[ ,1])>0)
		warning("The two input density matrices do not have the same x coordinates.")

	mean.1 <- (density.1[ ,1]%*%density.1[ ,2])/sum(density.1[ ,2])
	mean.2 <- (density.2[ ,1]%*%density.2[ ,2])/sum(density.2[ ,2])
	
	if(mean.1 > mean.2){
		density.of.positives <- density.1
		density.of.negatives <- density.2
		first.one.positive <- TRUE
		mean.positive <- mean.1
		mean.negative <- mean.2
	} else {
		density.of.positives <- density.2
		density.of.negatives <- density.1
		first.one.positive <- FALSE
		colors <- rev(colors)	#changing the colors appropriately.
		mean.positive <- mean.2
		mean.negative <- mean.1
		print("change in input order.")
	}#End elseif.	
		
	# xlim-ylim:
	x.range <- c(density.of.positives[ ,1],density.of.negatives[ ,1])
	y.range <- c(density.of.positives[ ,2],density.of.negatives[ ,2])
	y.range 
	if(is.null(xlim))
		xlim=c(min(x.range),max(x.range))		
	if(is.null(ylim))
		ylim=c(min(y.range),max(y.range))

	# ploting:	
	if(do.plot){
		par(mar=1.15* (c(5, 4, 4, 2)) +0.01, cex.lab=2.3)
		plot(density.of.positives, type="l", col=colors[1],xlim=xlim,ylim=ylim)
		par(new=TRUE)
		par(mar=1.15* (c(5, 4, 4, 2)) +0.01, cex.lab=2.3)
		plot(density.of.negatives, type="l", col=colors[2],xlim=xlim,ylim=ylim)
		abline(v=mean.positive,col=colors[1])
		abline(v=mean.negative,col=colors[2])
		box()
	}#End if(do.plot)
	
	# computing the errors:
	errors <- c()
	for (i in 1: (dim(density.of.positives)[1]-1) ){
		X <- density.of.positives[i,1]
		#message("X is: ", X)
		if(do.plot)
			abline(v=X, col="grey")

		positive.error.curve <- density.of.positives[which(density.of.positives[ ,1]<X), ]
		negative.error.curve <- density.of.negatives[which(density.of.negatives[ ,1]>X), ]
		error.positives <- compute.area.under.the.curve(positive.error.curve)
		error.negatives <- compute.area.under.the.curve(negative.error.curve)		
		errors[as.character(density.of.positives[i,1])] <- error.positives + error.negatives

		# for debugging:
		if(debug.message){
			message("error.positives: ",error.positives)
			message("error.negatives: ",error.negatives)		
			message("difference: ",error.positives-error.negatives)				
			message("error: ",errors[i])		
		}#End if(debug.message).
		#points(errors*(max(ylim)/max(errors)),xlim=xlim,ylim=ylim)
		if(do.plot){
			errors.plotable <- errors*(max(ylim)/errors[1])
			points(density.of.positives[1:i,1],errors.plotable[1:i],type="l",lwd=2,xlim=xlim,ylim=ylim)
			points(density.of.positives[i,1],error.positives*(max(ylim)/errors[1]),pch=20,xlim=xlim,ylim=ylim,col=colors[1])
			points(density.of.positives[i,1],error.negatives*(max(ylim)/errors[1]),pch=20,xlim=xlim,ylim=ylim,col=colors[2])
		}#End if.
	}#End for.
	
	min.indices <- which.min(errors)
	cutoff.index <- round(median(min.indices))
	cutoff.x <- density.of.positives[cutoff.index,1]
	cutoff.y <- density.of.positives[cutoff.index,2]
	if(do.plot)
		abline(v=cutoff.x,col="red",lwd=3)
						
	result<- list(cutoff.index=cutoff.index,errors=errors,cutoff.x=cutoff.x,cutoff.y=cutoff.y,first.one.positive=first.one.positive)
	#print("find ending");a()	
	return(result)									
}#End plot.ratio.and.histogram  <- function. 

