plot.histogram.comparsion <-
function(feature.values =patcode.2.MCL.SLL.feature[["score"]], breaks="Sturges",
								ylim=NULL, xlim=NULL,colors=c(6,4),maping, estimate.density=TRUE,
								ylab=NULL,xmargine=0.1,beside=TRUE,border.color="green",border.thickness=3,
								plot.cutoff.finding=FALSE,type.colors=c(),args.legend=NULL,add.legend=TRUE,legend.text=NULL,
								histogram.space=NULL,	# NULL(default)
								do.plot.bars=TRUE,		# set it to FALSE to plot the threshould plot for paper
								xlable,ylable,
								...){
#HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
# provided with the feature values, this function plots the histograms for each type.
# If estimate.density=TRUE, the probability distributions for each type of desease are estimated using a Gaussian kernel.
#a();g()			
	density.of <- list()
	# reading data-aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa
	if(class(feature.values)!="numeric")
		stop("!! feature values should be a numeric vector.")
	MCL.SLL.type <- patcode.2.type(names(feature.values),maping=maping)
	values.for_MCL <- feature.values[which(MCL.SLL.type=="MCL")]
	values.for_SLL <- feature.values[which(MCL.SLL.type=="SLL")]
	if(length(values.for_MCL)==1){
		warning("Only one MCL case! Anomalized for density estimation.")
		values.for_MCL <- c(values.for_MCL,values.for_MCL+sd(feature.values),values.for_MCL-sd(feature.values))
	}#End if.
	if(length(values.for_SLL)==1){
		warning("Only one SLL case! Anomalized for density estimation.")
		values.for_SLL <- c(values.for_SLL,values.for_SLL+sd(feature.values),values.for_SLL-sd(feature.values))
	}#End if.
	#print("hist");a()
	# computing histograms-ssssssssssssssssssssssssssssssssssssssssssss	
	breaks.MCL <- hist(values.for_MCL, breaks=breaks,plot=FALSE)$breaks
	breaks.SLL <- hist(values.for_SLL, breaks=breaks,plot=FALSE)$breaks
	breaks <- sort(union(breaks.MCL, breaks.SLL))
	#print("This might need adjustment (breaks).")		
	counts.MCL <- hist(values.for_MCL, breaks=breaks,plot=FALSE)$counts
	counts.SLL <- hist(values.for_SLL, breaks=breaks,plot=FALSE)$counts
	#density
	density.of[["MCL"]] <- density(values.for_MCL)
	density.of[["SLL"]] <- density(values.for_SLL)
	#x.range <- sort(union(density.of[["MCL"]]$x,density.of[["SLL"]]$x))

	# putting the two histograms together.
	counts <- rbind(counts.MCL, counts.SLL)	
	row.names(counts) <- c("MCL","SLL")
	total.number <- sum(counts)
	counts <- (counts/sum(counts))*100 # computing percentage
	interval.means <- (breaks[1:(length(breaks)-1)] + breaks[2:length(breaks)])/2
	colnames(counts) <- interval.means
	#ploting barplots:bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb
	if(add.legend){
		legend.text <- rownames(counts)
	}#End if.	
	if(is.null(ylim))
		ylim <- c(0,max(counts)*1.1)
	if(is.null(ylab))	
		ylab <- ""	
		##ylab <- "number of cases (%) / scaled density"	
		#ylab <- "estimated density"	# threshould plot for paper
	#
	# to set xlim	
	dev.new()		
	par(mar=1.15* (c(5, 4, 4, 2)) +0.01, cex.lab=2.3)

	barplot.result <- barplot(counts, col=type.colors[c("MCL","SLL")],beside=beside, axes=TRUE, ylab=ylab,  ylim=ylim, xaxs="i",yaxs="i",
		args.legend=args.legend, legend.text=legend.text,space=histogram.space,cex.names=2,...)
	dev.off()

	# seting xlim
	length.temp <- max(barplot.result)-min(barplot.result)		
	xlim <- c(min(barplot.result)- xmargine*length.temp,max(barplot.result)+ xmargine*length.temp)	
		# Normally, 4% is added by R for cosmetic puposes. (look at: ?par(), R documentation)
	#********************************************************************************************************
	par(mar=1.15* (c(5, 4, 4, 2)) +0.01, cex.lab=2.3)
	barplot.result <- barplot(counts*do.plot.bars, col=type.colors[c("MCL","SLL")],args.legend=args.legend,legend.text=legend.text, beside=beside,
			axes=TRUE, ylab=ylab, ylim=ylim, xlim=xlim,xaxs="i",space=histogram.space,cex.names=2,...)			
	#****************************************************************************************************
	rownames(barplot.result) <- rownames(counts)
	colnames(barplot.result) <- colnames(counts)	
	#bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb
	#
	# Adding density estimations:ddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd
	if(estimate.density){
		# Adding density continues estimation 	
		density.curve <- list()	# density.curve[["MCL"]] will be a 500*2 matrix 
								# that contains coordinates of points of the MCL density curve.
		d <- list()				# will contain the density of each type.
		x <- list()				# the corresponding x coordinates.				
		for (ith.type in c("MCL","SLL")){
			nonzero.bars <- which(counts[ith.type,]!=0)
			comparsion.temp <- barplot.result[ith.type, c(nonzero.bars[1],tail(nonzero.bars,1))]
			#
			scale.end.points <- function(input.values, according.to,inverse=FALSE){ 
				# Computes: Z = x + (y-x)/(b-a) * (C-a) 
				# according.to=c(x,y) is a vector named with a and b.
				# If inverse=TRUE, then computes: C = (Z-x) / ((y-x)/(b-a)) + a
				result <- c()		
				ordered.values <- ordered.H(input.values)
				start <- min(ordered.values)
				end <- max(ordered.values)
				a <- as.numeric(names(according.to)[1])
				b <- as.numeric(names(according.to)[2])
				x <- according.to[1]
				y <- according.to[2]
				if(!inverse){
					result["start"] <- x + ((y-x)/(b-a)) * (start-a)
					result["end"] <- x + ((y-x)/(b-a)) * (end-a)
				} else {	
					result["start"] <- (start-x)/((y-x)/(b-a)) + a
					result["end"] <- (end-x)/ ((y-x)/(b-a)) + a 
				}#End ifelse.	
				return(result)
			}#End scale.end.points <- function.
			#
			end.points <- scale.end.points(input.values=density.of[[ith.type]]$x,according.to=comparsion.temp)
			#last.nonzero.bar <- tail(nonzero.bars,1)
			#plot.range <- barplot.result[ith.type,min(nonzero.bars):max(nonzero.bars)]
			par(new=TRUE)
			d[[ith.type]] <- density.of[[ith.type]]$y /max(density.of[[ith.type]]$y)*max(counts[ith.type,])
			x[[ith.type]] <- normalize.in_range(density.of[[ith.type]]$x,end.points["start"],end.points["end"])
			density.curve[[ith.type]] <- cbind(x[[ith.type]],d[[ith.type]])
			colnames(density.curve[[ith.type]]) <- c("x","density")
			# ploting:PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
			par(mar=1.15* (c(5, 4, 4, 2)) +0.01, cex.lab=2.3)
			plot(x[[ith.type]], d[[ith.type]], type='l',col=type.colors[ith.type], xaxs='i', xlim=xlim, 
				ylab=ylable,axes=FALSE,lwd=2,yaxs="i",ylim=ylim, xlab=xlable)
				# X11(); plot(density.of[[ith.type]]$x, density.of[[ith.type]]$y)	#for debuging.
			par(new=TRUE)
			par(mar=1.15* (c(5, 4, 4, 2)) +0.01, cex.lab=2.3)
			plot(x[[ith.type]], d[[ith.type]], type='l',col="black",xaxs='i',xlim=xlim,xlab=xlable,ylab=ylable,axes=FALSE, 
				lwd=0.5,yaxs="i",ylim=ylim)
				# to draw the cosmetic thin line.
			#PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP	
			#
		}#End 	for (ith.type in c("MCL","SLL").
		#print("find-calling"); plot.cutoff.finding <- FALSE; a()
		#
		# cutoff			
		find.cutoff.for_histogram <- find.cutoff(density.1=density.curve[["MCL"]],density.2=density.curve[["SLL"]],
										colors=type.colors,xlim=xlim,ylim=ylim, do.plot=plot.cutoff.finding)
			# The coordinates are scaled.	
		cutoff.x <- find.cutoff.for_histogram$cutoff.x
		abline(v=cutoff.x,col=border.color,lwd=border.thickness,lty="longdash")
		#print("found")				
		#
		# real
		MCL.density <- cbind(density.of[["MCL"]]$x,density.of[["MCL"]]$y)
		SLL.density <- cbind(density.of[["SLL"]]$x,density.of[["SLL"]]$y)		
		find.cutoff.real.value <- find.cutoff(density.1=MCL.density,density.2=SLL.density,
										colors=type.colors,do.plot=FALSE)
		#
		if(find.cutoff.real.value$first.one.positive){
			positive.type <- "MCL"
		} else 
			positive.type <- "SLL"
		#
		cutoff.value <- density.of[[positive.type]]$x[find.cutoff.real.value$cutoff.index]
			# cutoff.value is the real value for cutoff.
		if(!find.cutoff.real.value$first.one.positive)
			cutoff.value <- cutoff.value * 1i
			# If th efirst one is not positive, then we need to remember it by using complex numbers:
		cutoff.errors <- find.cutoff.real.value$errors
	}#End if(estimate.density).dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd
	# Bayes error for paper,BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
		temp.inds <- which(x[["SLL"]] > cutoff.x)
		loop.inds <- c(temp.inds,tail(temp.inds,1),temp.inds[1])
		#polygon(x[["SLL"]][loop.inds],c(d[["SLL"]][temp.inds],0,0),col='brown',density=30)
		temp.inds <- which(x[["MCL"]] < cutoff.x)
		loop.inds <- c(temp.inds,tail(temp.inds,1),temp.inds[1])
		#polygon(x[["MCL"]][loop.inds],c(d[["MCL"]][temp.inds],0,0),col='brown',density=30)	
	#BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
	#
	box()
	density.plots=list(d=d,x=x)
	#print("hist end.")	;a()	
	return(list(percentages=round(counts,2),total.number=total.number, densities=density.of,cutoff=cutoff.value,cutoff.errors=cutoff.errors, 
		densitt.plots=density.plots))
#HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
}#End plot.histogram.comparsion <- function.

