plot.on.hard <-
function(S=Settings,path, feature,features.names,maping,presentable.feature.names=names(feature),
					lwd=2,exclude.features=c("score","classic"),
					curve.colnames=c("FP","TP"),type.colors=1:2,project.section=NA, do.plot.componets=FALSE,
					clinical.tests=NULL,...){
#HARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHARDHAR
### Plots ratios and histograms on hard. Also, computes total score (based on ratios) and classic score (based on FMC7 and CD23).
### INPUT: feature[["CD23.intensity"]] is a vecotor indexed by patcodes.
###			on the tube that contains FMC7 and CD23.
###			... will be passed to plot.components.comparatively(...)
	cutoffs <- c()	#cutoffs["FMC7.CD23.ratio"] is the best threshould computed by find.cutoff() function.
	B.cell.components.plot <- list()	# The results of compute.ratio while ploting components.
	print("--- comparative plots on hard ---")
	print("All graphic devices are shut down to prevent conflict.")
	feature.update <- feature
	for (feature.name in features.names){	# for example: "FMC7.CD23.ratio"	
		if(feature.name %in% exclude.features)
			next	# All cuttoffs are not determined yet.
		add.legend.histogram <- feature.name %in% c("CD20.CD23.ratio", "CD23.intensity")#,"FMC7.intensity")
		add.legend.ratio <- feature.name %in% c("CD20.CD23.ratio")#,"FMC7.intensity")		
			#Add legends only for these features.			
		file.name.prefix <- replace.character(feature.name,"\\.",with="_")
		#HISTOGRAM:	
		title <- feature.name.2.title(feature.name)
		message("[-",title,"----------------]")
		values <- feature[[feature.name]]
		# add ylab only to some plots.
		histogram.ylab <- NULL	
		if (!feature.name %in% c("CD20.CD23.ratio","CD23.intensity")) 
			histogram.ylab <- NA
		postscript(file=paste(path,"/",file.name.prefix,"_histogram.eps",sep=""))		
#***************************************************************************************************************************************	
			h.temp <- plot.histogram.comparsion(feature.values=values,  ylim=NULL,xlab=NA,ylab=histogram.ylab,
				maping=maping, type.colors=type.colors, add.legend=add.legend.histogram, 
				args.legend=list(cex=2),histogram.space=c(0,0),xlable=title, ylable="Bars(%)/ Lines(estimated density)")	
		#**************************************************************************************************************************************	
		dev.off()	
		cutoffs[feature.name] <- h.temp$cutoff
		# RATIO:		
		postscript(file=paste(path,"/",file.name.prefix,".eps",sep=""))	
		#**************************************************************************************************************************************		
			r.temp <- plot.ratio(ratio=values,cutoff=Mod(cutoffs[feature.name]),standard.patients=feature[["standard"]],
				path=NA,title="",reverce=TRUE,ylab=title,input.colors=type.colors,clinical.tests=clinical.tests,cex=3,
				legcex=2, add.legend=add.legend.ratio, xlab=NA,cex.axis=2, maping=maping)
		#**************************************************************************************************************************************			
		dev.off()	
	}#End for (feature.name.
	print("hists and ratios done")	#;a()
	#
	# CLASSIC:
		feature.update[["classic"]] <- compute.classic.score(feature=feature,cutoffs=cutoffs,ploting.path=path,
											maping=maping,type.colors=type.colors,clinical.tests=clinical.tests)
		cutoffs["classic"] <- 1
	#
	# SCORES:
		feature.update[["score"]] <- compute.total.score(feature=feature,cutoffs=cutoffs,ploting.path=path,maping=maping,
											type.colors=type.colors,clinical.tests=clinical.tests)
		cutoffs["score"] <- 1.5
	#
	# ROC:
		# The sensitivity-speciicity curve
		library(caTools)
		features.table <- do.call(cbind,feature.update)[ ,features.names]	# a matrix of interested features.
		colnames(features.table) <- presentable.feature.names[colnames(features.table)]
		labels.temp <-  patcode.2.type.num(patCode.input=rownames(features.table),maping=maping)
		#ploting:
		postscript(file=paste(path,"/","ROC.eps",sep=""))		
		#****************************************************************************************************************
			ROC.result <- plot.ROC(values=features.table,labels=2-labels.temp,lwd=lwd,curve.colnames=curve.colnames)
		#****************************************************************************************************************	
		dev.off()
		print("ROC ploted.")#;a()	
	#
	# COMPONENTS:
		if(do.plot.componets)
			temp <- plot.components.paper(S=S,path=path,cutoffs=cutoffs,...)	
	result <- list(cutoffs=cutoffs, auc=ROC.result$AUC,feature=feature.update,ROC.curve=ROC.result$ROC.curve, 
		features.table=features.table, maping=maping, type.colors=type.colors)
	return(result)
}#End plot.on.hard <- function.	

