sum.curves <-
function(curve1,curve2,weight1=1,weight2=1, do.show=FALSE,resolution=100){
### A curve is a n*2 matrix representing (x,y) coordinates.sssssssssssssssssssss
### Computes the curve representing the sum of the input curves.sss
	result <- c()
	# weights:
	curve1[ ,2] <- weight1 * curve1[ ,2]
	curve2[ ,2] <- weight2 * curve2[ ,2]
	#Turning the curves into functions:
	X <- c(curve1[ ,1],curve2[ ,1])
	X <- sort(X,decreasing=TRUE)
	domain <- max(X) - diff(range(X)) * (1:resolution/resolution)
	curve1.f <- functionize(curve1,domain=domain)
	curve2.f <- functionize(curve2,domain=domain)
	#
	if(do.show){
		X11();plot(curve1,col="darkblue",xlim=c(0,1),ylim=c(0,1));a()
		points(curve1.f,col="blue",pch=20);a()
		points(curve2,col="darkred");a()
		points(curve2.f,col="red",pch=20);a()			
	}#End if.	
	#
	#plot(curve1,ylim=c(-1,2),main=weight2);points(curve2,col='blue');a()
	#curve1 <- linear.interpolation(curve=curve1,point.x=X)
	#curve2 <- linear.interpolation(curve=curve2,point.x=X)
	for (xx in domain){
		y1 <- mean(curve1.f[curve1.f[ ,1]==xx,2])	
			# the average of y coordinate of all points on the line X=xx
		y2 <- mean(curve2.f[curve2.f[ ,1]==xx,2])	
		yy <- y1 +  y2
		#print(yy)
		result <- rbind(result,c(xx,yy))
	}#End for.
	if(do.show){
		points(result,type='l');a();dev.off()
	}#End if.
	return(result)
}#End sum.curvesssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss

