reproduce <-
function(path.plot=".", S=NULL, do.plot.DLBCL.FOLL.components=FALSE, do.latex.table=FALSE,  do.save.feature.table=FALSE, constants=NULL, ter=FALSE){
# do.save.for_combining=TRUE => saves data to produce plots showing CD20/CD23 ratio vs. FMC7. 
### Initialization:	################################################################################################################################
		start.time.MCL.SLL.report <- Sys.time()
		message("Started at: ", start.time.MCL.SLL.report)
		##
		par(mar=1.15* (c(5, 4, 4, 2)) +0.01, cex.lab=2.3)
		## data(whole)
		 	# all globall variables are saved.
		if(is.null(S)){		 	
			data(Settings)
			S <- Settings
		}#End if.	

		if(is.null(constants)){		 	
			data(all.used.constants)
			constants <- all.used.constants
		}#End if.	
		
		Settings
		
		data(list=constants)
		data(clinical.tests.coded)
		clinical.tests <- clinical.tests.coded
			# clinical.tests is loaded.
		#rownames(clinical.tests) <- decrypt(rownames(clinical.tests))
		#plot.results <- TRUE
		report.agency.numbers <- FALSE
		# do.compute.feature.values <- TRUE			# If FALSE, the analysis will not be repeated.
		do.compute.feature.values <- FALSE
		do.save <- FALSE
	
		patcode.2.MCL.SLL.feature <-list()			# Example: patcode.2.MCL.SLL.feature[["score"]]
													# For each patcode, the total score is equal to the number of
													# features which are greater than the threshould.
													
		patcode.2.MCL.SLL.standard <-c()			# The standardd definitionn of MCL is 5+ 23- fmc7 usually+ 
													# whereas SLL is 5+ 23+ fmc7 usually-." 																	

		patcode.2.time.frame <- c()
		#path.plot <- paste(path.local,"/",project.name,"/","result/MCL-SLL",sep="")
			# The resulting plots will be saved here.
		path.plot <- paste(path.plot,"ratios/",sep="/")
		dir.create(path.plot,showWarnings=FALSE)
		#path.CD23.FMC7 <- paste(path.local,"/",project.name,"/","result/MCL-SLL/CD23_FMC7/",sep="")		
			# only the third period is required for the paper.
		plot.on.hard.results <- list()				# stores computed results for each project section.
		###CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
		result.numbers <- list()					# The TP(True Positive), TN, FP, FN numbers 
													# for each feature in each project.section.
		result.numbers[["all"]] <- 0
		result.numbers[["test"]] <- 0
		cutoffs <- list()							# cutoffs[[project.section]] is a vector indexed by features names.
		patcode.2.diagnosis.all <-c()				# It will be obtained by merging patCode.2.diagnosis for all datasets.
		auc <- list()								# Area under the ROC curve.
		ROC.curves <- list()
		volume <- c()	# The number of cases in each project section.
		number.of.positives <- c()
		graphics.off()
		#
		for(project.section in all.project.sections){#SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
			# FOR ALL PROJECT SECTIONS the analysis should be done or loaded:
			print(paste("*================ [",project.section,"]================*"))
			project.dataset <- project.section.2.project.dataset(project.section)
			time.period <- strsplit(project.section,split="/")[[1]][2]			
			#
			# Analysis:
			if(! do.compute.feature.values){
				if(do.plot.DLBCL.FOLL.components){
			 		source("paths.R")
			 		source("loading.R")	
			 		#clusters will be needed.
			 	}#End if.	
			 	# info:
			 	load.info(project.dataset)
				if(contains(input.string=project.section, replacable="8_color")){	
		 			patCode.2.diagnosis <- patCode.2.diagnosis.coded
					patcode.2.period <- patcode.2.period.coded
				}#End if.	
			 	# feature:
					#load(file=paste("../result/MCL-SLL/feature/",project.section,"/feature.RData",sep=""))
						# feature is loaded.
					if(do.compute.feature.values)	
						save(feature,file=paste("../result/MCL-SLL/feature/", 
							replace.character(project.section,"/",with="_"), "_feature.RData",sep=""))
						# for package
					try(rm(feature),silent=TRUE)	
					load.feature(project.section)
						# feature is loaded.
					if(contains(input.string=project.section, replacable="8_color"))	
						feature <- feature.coded
			} else
				#print("specific_studies/MCL.SLL.analysis.R  ?"); a()			
				source("specific_studies/MCL.SLL.analysis.R")
			#	
			# all.patcodes
			patcode.2.diagnosis.all[names(patCode.2.diagnosis)] <- patCode.2.diagnosis
			patcode.2.time.frame[names(patcode.2.period)] <- period.2.frame[patcode.2.period]
			message("                         <", length(feature[[1]]), " patients.>")
			#
			# PLOTING:
			path.plot.ratios <- paste(path.plot,project.section,sep='')
			dir.create(path.plot.ratios,showWarnings=FALSE,recursive=TRUE)
			palette("default")	
			#**********************************************************************************************
			#plot.on.hardplot.on.hardplot.on.hardplot.on.hardplot.on.hardplot.on.hardplot.on.hardplot.on.ha
			#______________________________________________________________________________________________
			plot.on.hard.results[[project.section]] <- plot.on.hard(path=path.plot.ratios, feature=feature,
				features.names=features.names,maping=patcode.2.diagnosis.all,										
				presentable.feature.names=presentable.feature.names,										
				curve.colnames=ROC.curve.colnames,										
				type.colors=type.colors,
				do.plot.componets=(project.section=="3_color/third.period" & do.plot.DLBCL.FOLL.components),
				clinical.tests=clinical.tests,
				S=Settings)
			#plot.on.hardplot.on.hardplot.on.hardplot.on.hardplot.on.hardplot.on.hardplot.on.hardplot.on.har
			#_______________________________________________________________________________________________	
			#***********************************************************************************************
			#
			# renaming	
			cutoffs[[project.section]] <- plot.on.hard.results[[project.section]]$cutoffs
			ROC.curves[[project.section]] <- plot.on.hard.results[[project.section]]$ROC.curve
			volume[project.section] <- length(feature[["standard"]])	
			number.of.positives[project.section] <-  sum(patcode.2.type(names(feature[["standard"]]))=="MCL")
				# The sum is weighted by the number of cases in this project section.
			feature <- plot.on.hard.results[[project.section]]$feature	
				# updating feature to include classic and total ratio scores.
			#
			### Calculating the accuracy:
			print("Calculating accuracy...")
			result.numbers[[project.section]] <- c()	# Each row will contain TP,TN,FP and FN for a feature.
			for (i in 1: length(features.names)){
				feature.name <- features.names[i]
				#print(feature.name)
				threshould <- cutoffs[[project.section]][[feature.name]]
				if(Im(threshould)!=0){	# positives should have higher values.
					increasing.feature <- feature[[feature.name]] * (-1)
					threshould <- threshould*(1i)	# 1i*1i=(-1)
				} else
					increasing.feature <- feature[[feature.name]]
				threshould <- Re(threshould)
				#****************************************************************************************************
				new.numbers <- compute.accuracy(feature=increasing.feature,threshould=threshould,type.num=1)$numbers
				#*****************************************************************************************************
				result.numbers[[project.section]] <- rbind(result.numbers[[project.section]],new.numbers)
				rownames(result.numbers[[project.section]])[i] <- feature.name
				patcode.2.MCL.SLL.feature[[feature.name]] <- c(patcode.2.MCL.SLL.feature[[feature.name]], 
					feature[[feature.name]])			
				#print(result.numbers[[project.section]]);a()
			}#End for (featur.name in names(feature)).	
			# Adding the result of project section together to compute the total result:
			result.numbers[["all"]] <- 	result.numbers[["all"]] + result.numbers[[project.section]]
			if(project.section!="3_color/third.period")
				result.numbers[["test"]] <- result.numbers[["test"]] + result.numbers[[project.section]]
			patcode.2.MCL.SLL.standard <- c(patcode.2.MCL.SLL.standard,feature[["standard"]])
			auc[[project.section]] <- plot.on.hard.results[[project.section]]$auc
		}#End for(project.section.(project.section.SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS	
		#
		# features for all patients
		features.table <- do.call(cbind,patcode.2.MCL.SLL.feature)[ ,features.names]	# a matrix of interested features.
		features.table <- cbind(features.table,time.frame=patcode.2.time.frame[rownames(features.table)])
		colnames(features.table) <- presentable.feature.names[colnames(features.table)]
		#
		# ROC and AUC:
		auc <- do.call(cbind,auc)	# a matrix of auc.
		pfn <- presentable.feature.names[features.names]
		pfn <- pfn[pfn!="classic routine (FMC7+ & CD23-)"]
		fn.temp <- pfn[pfn!="CD5 intensity"]
		weight <- number.of.positives/sum(number.of.positives)
		#weight <- volume/sum(volume) wrong.
		#**************	***********************************************************************************************
		whole.plot <- compute.average.ROC(curves=ROC.curves, weight=weight, curve.colnames=ROC.curve.colnames, lwd=1.5,
				path=path.plot,legend.title="AUC (Area Under the Curve)", legend.show="AUC", show.zoom.area=FALSE,
				features.names=pfn, title=NULL, skip="FMC7-CD23", compute.average.ROC=FALSE,
				point.to.classic=FALSE)
		#**************************************************************************************************************
		ROC.efficient <- compute.average.ROC(curves=ROC.curves,weight=weight,curve.colnames=ROC.curve.colnames,lwd=1.5,
		path=path.plot,above=0.5,below=0.5,file.name="efficient-ROC", legend.title="*Efficient area under the ROC curve",
		features.names=fn.temp, show.diagonal=FALSE,skip="FMC7-CD23")
		#
		# total scores:
		all.scores <- patcode.2.MCL.SLL.feature[['score']]
		all.scores.matrix <- compute.Y.and.order(input.features.matrix=all.scores,
				rowname.2.diagnosis=patcode.2.diagnosis.all)$ordered.features
		all.scores <- as.numeric(all.scores.matrix)
		names(all.scores) <- rownames(all.scores.matrix)
		postscript(file=paste(path.plot,"total_scores.eps",sep=""))		
			palette("default")
			temp <- plot.ratio(ratio=all.scores, cutoff=1.5, standard.patients=patcode.2.MCL.SLL.standard,
				path=NA,title="",reverce=TRUE,ylab=presentable.feature.names["score"], 
				maping=patcode.2.diagnosis.all,location_legend="bottomright",
				clinical.tests=clinical.tests, 
				legcex=1.5,cex=1.5,yaxt="n")
			axis(2,0:3,cex.axis=2) 	
			##axis(1,1:length(all.scores),cex.axis=1.5); axis(2,0:3,cex.axis=2); 
			box()	
		dev.off()
		# finishing	
		print("Results from all project sectionns are ploted.")	
		combined <- list(patcode.2.MCL.SLL.standard=patcode.2.MCL.SLL.standard,
						TPFN.numbers=result.numbers,
						cutoffs=cutoffs,
						patcode.2.diagnosis.all=patcode.2.diagnosis.all,
						auc=auc,ROC.efficient=ROC.efficient,
						features.table=features.table)
	###CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
	#
	##
	### total performance:
	### ppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppp
		performance <- numbers.2.performance(numbers=combined$TPFN.numbers[["all"]],features.names=features.names)
		performance.test <- numbers.2.performance(numbers=combined$TPFN.numbers[["test"]],features.names=features.names)
		rownames(performance) <- presentable.feature.names[rownames(performance)]
		rownames(performance.test) <- presentable.feature.names[rownames(performance.test)]
		efficient_AUC <- ROC.efficient$efficient.AUC
		Gini_index <- ROC.efficient$Gini
		#Extra:	
		average_AUC <- rowMeans(combined$auc)
		average_AUC <- format(average_AUC,nsmal=2)
		average_Gini_index <- 2*as.numeric(average_AUC)-1
		average_Gini_index <- format(average_Gini_index,nsmal=2)
		#performance <- cbind(performance,efficient_AUC,Gini_index) 
		print("performance:__________ (TEST)")
		print(performance.test)		
		message("-------------------------------------------------------------------\n")		
		print(" performance:__________ (ALL)")
		print(performance)
		message("-------------------------------------------------------------------\n")
	#ppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppp	
	#
	##
	### standard:
	#RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
		message("typical cases: ", sum(combined$patcode.2.MCL.SLL.standard==TRUE))
		message("atypical cases: ",  sum(combined$patcode.2.MCL.SLL.standard==FALSE))
		#standard <- rownames(combined$patcode.2.MCL.SLL.standard)[which(combined$patcode.2.MCL.SLL.standard)]
		#standard <- rownames(patcode.2.MCL.SLL.standard)[which(!patcode.2.MCL.SLL.standard)]
		table.TeX <- c()
		if(do.latex.table){
			# presenting result if LaTeX
			library(xtable)	# for producing LaTeX tables
			table.TeX <- xtable(performance, floating=FALSE, digits=0)	
			align(table.TeX) <- "|l|r|r|r|r|r|r|r|"
			print("Accuracy result is stored in 'table.TeX' as a LaTeX table.")
		}#End if.
	#RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR	
	#
	##
	### Reporting Agency numbers: 
	#nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn
	if(report.agency.numbers){
		patcodes.temp <- rownames(combined$patcode.2.MCL.SLL.standard)
		agency_id <- c()
		for(patcode in patcodes.temp){
			if(contains(input.string=patcode,replacable="BCCA")){	# 8color data
				agency_id[patcode] <- strsplit(patcode,"_-_")[[1]][2]
			} else 	# 3color
			agency_id[patcode] <- as.character(patcode.2.info(patCode.input=patcode)["agency_id"]$agency_id)
		}#End for(patcode in patcodes).
		table.temp <- as.matrix(agency_id)
		table.temp <- cbind(table.temp,combined$patcode.2.MCL.SLL.standard)	# adding info about difficulty
		table.temp <- replace.character(input.string=table.temp,replacable="BCCA",with="")	# removing "BCCA"
		colnames(table.temp) <- c("flow number / PATCODE", "standard")
		# write.table(file="agency.numbers.csv",table.temp,sep=',') 
	}#End if.	
	#nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn
	#
	##
	### Saving
	# features table
	if(FALSE){
		cto <- clinical.tests.original	#abraviation
		patcodes <- as.character(cto[ ,"flow.number...PATCODE"])
		table.all <- cbind(patcodes, cto[ ,c("BCCA.","standard","FISH.11.14","cyclin.D1.IHC","Diagnosis")], 
			features.table[patcodes, ])
		colnames(table.all)[1:6] <-  c("flow number / PATCODE", "BCCA #","typical","FISH 11;14","cyclin D1 IHC","Diagnosis")
		if ( do.save.feature.table ){			
			write.table(table.all,
				file=paste("/home/habil/Lymphoma/papers/talks_and_preentation_by_us/MCL.SLL/Supplements/"
					,"Supplementary_Table_A.csv", sep=""), sep=',',row.names=FALSE)
			#save.image(file=paste(workspace.path,"MCL.SLL.report.RData",sep='/'))	
		}#End if.
	}#End if(FALSE).
	#
	{message("\n\n################################################################################################");
	message("###");
	message("***    Plots were saved on hard at: ",path.plot);
	message("###");
	message("################################################################################################\n\n");}
	########################### E N D ###########################
	print("Reports are done.")
	end.time.MCL.SLL.report <- Sys.time()
	total.time.MCL.SLL.report <- end.time.MCL.SLL.report - start.time.MCL.SLL.report
	print("Total time: ")
	print(total.time.MCL.SLL.report)
	message("___________________________________")
	### Outputing:
	result <- list(discrimination=result.numbers, patcode.2.MCL.SLL.featrue=patcode.2.MCL.SLL.feature,
						patcode.2.MCL.SLL.standard=combined$patcode.2.MCL.SLL.standard, 
						table.R=performance,table.test.R=performance.test,table.TeX=table.TeX,
						efficient_AUC=efficient_AUC,Gini_index=Gini_index,
						features.table=combined$features.table, patcode.2.diagnosis=patcode.2.diagnosis.all,
						plot.on.hard.results=plot.on.hard.results)
	if(do.save){
		print("Savning results to produce combining plots later (in combining.R).")
		save(result,file="/home/habil/Lymphoma/result/MCL-SLL/other/MCL.SLL.result.RData")
	}#End if.	
	if(ter)					
		return(result)
}#End reproduce <- function(path=".").

